package cc.smtweb.system.bpm.web.engine.model.flow.listcard.single;

import cc.smtweb.framework.core.common.R;
import cc.smtweb.framework.core.common.SwMap;
import cc.smtweb.framework.core.db.impl.DefaultEntity;
import cc.smtweb.framework.core.mvc.service.SwListData;
import cc.smtweb.system.bpm.web.design.form.define.PageDataset;
import cc.smtweb.system.bpm.web.engine.dynPage.AbstractDynPageHandler;
import cc.smtweb.system.bpm.web.engine.dynPage.DynRetBean;
import cc.smtweb.system.bpm.web.engine.flow.FlowHelper;
import cc.smtweb.system.bpm.web.engine.flow.FlowInstance;
import cc.smtweb.system.bpm.web.engine.flow.FlowListener;
import cc.smtweb.system.bpm.web.engine.flow.entity.Task;
import cc.smtweb.system.bpm.web.engine.model.listcard.single.LCSingleHelper;

import java.util.List;

/**
 * Created by Akmm at 2022-09-01 15:03
 * 流程流转
 */
public class FlowTransHandler<T extends DefaultEntity> extends AbstractDynPageHandler implements FlowListener{
    //流程id
    protected long billId;
    //任务id
    protected long taskId;
    protected FlowInstance flowInstance;

    protected T bean;

    private SwMap buildRetData() {
        SwMap ret = new SwMap();
        ret.put(LCSingleHelper.DATASET_NAME_CARD, DynRetBean.createBean(bean));
        ret.put(FlowHelper.DATASET_NAME_FLOW, DynRetBean.createBean(flowInstance.getProcInst()));
        ret.put(FlowHelper.DATASET_NAME_COMMENT, DynRetBean.createList(SwListData.EMPTY));
        flowInstance.setPageRetExtra(ret);
        return ret;
    }

    protected void load() {
        if (flowInstance == null) {
            billId = params.readLong("id");
            taskId = params.readLong("taskId");
            flowInstance = FlowInstance.createById(us, this, billId, taskId);

            loadBean();
        }
    }

    protected void loadBean() {
        PageDataset cardDataset = LCSingleHelper.findCardDataset(datasets);
        bean = provider.loadBean(cardDataset, billId);
    }

    public R submit() {
        load();
        flowInstance.submit(params.readString("comment"));
        return R.success(buildRetData());
    }

    public R retake() {
        load();
        flowInstance.retake();
        return R.success(buildRetData());
    }
}
