package cc.smtweb.system.bpm.web.engine.model.listcard.normal;

import cc.smtweb.framework.core.common.R;
import cc.smtweb.framework.core.common.SwMap;
import cc.smtweb.system.bpm.web.design.form.define.PageDataset;
import cc.smtweb.system.bpm.web.engine.dynPage.AbstractDynPageHandler;
import cc.smtweb.system.bpm.web.engine.dynPage.DynPageHelper;
import cc.smtweb.system.bpm.web.engine.dynPage.DynPageListHandler;
import cc.smtweb.system.bpm.web.engine.dynPage.DynRetBean;
import cc.smtweb.system.bpm.web.engine.model.listcard.single.LCSingleHelper;
import org.springframework.util.Assert;

/**
 * @Author:lip
 * @Date : 2022/8/29 14:37
 */
public class LCNormalLoadHandler extends AbstractDynPageHandler {

    //新增卡片操作，初始化定义的数据集
    public R add() {
        String dataSet = params.readString("dataset");
        PageDataset addDataSet = this.datasets.findByName(dataSet);
        Assert.notNull(addDataSet, "未获取到数据集:" + dataSet);
        SwMap data;
        //懒加载，给个空对象
        if (addDataSet.lazy) {
            data = new SwMap();
        } else {
            data = DynPageHelper.createBean(addDataSet);
        }

        return R.success(LCSingleHelper.buildRetData(addDataSet.name, data));
    }

    public R load() {
        //过滤条件
        SwMap filter = params.readMap("filter");

        //对应的数据集定义
        String dataSet = params.readString("dataset");
        PageDataset loadDataSet = this.datasets.findByName(dataSet);
        Assert.notNull(loadDataSet, "未获取到数据集:" + dataSet);

        SwMap data = provider.loadData(filter, loadDataSet);

        return R.success(LCSingleHelper.buildRetData(loadDataSet.name, data));
    }

    private DynPageListHandler getListWorker(SwMap filter, PageDataset pageDataSet) {
        DynPageListHandler listHandler = new DynPageListHandler(form.getId(), filter, pageDataSet);
        listHandler.init(params, us);
        return listHandler;
    }

    /**
     * 列表数据
     * @return
     */
    public R list() {
        //过滤条件
        SwMap filter = params.readMap("filter");

        //对应的数据集定义
        String dataSet = params.readString("dataset");
        PageDataset listDataSet = this.datasets.findByName(dataSet);
        Assert.notNull(listDataSet, "未获取到数据集:" + dataSet);

        DynRetBean bean = DynRetBean.createList(getListWorker(filter, listDataSet).buildListData());

        return R.success(bean);
    }

    /**
     * 计算分页数据
     *
     * @return
     */
    public R getTotal() {
        //过滤条件
        SwMap filter = params.readMap("filter");

        //对应的数据集定义
        String dataSet = params.readString("dataset");
        PageDataset listDataSet = this.datasets.findByName(dataSet);
        Assert.notNull(listDataSet, "未获取到数据集:" + dataSet);

        return getListWorker(filter, listDataSet).getTotal();
    }
}
